;DLL
Structure wAPI_func
   GetProcAddress.l
   LoadLibraryA.l
   LoadLibraryW.l
   LoadLibraryExA.l
   LoadLibraryExW.l
   
   MessageBoxA.l
   MessageBoxW.l
   
   ReplaceAdd.l
   ReplaceExec.l
   ReplaceExecEx.l
EndStructure
Global wAPI.wAPI_func

Global Hook_Enabled.l
Global Hook_Loaded.l
 
;/ remoteapi.dll Commands
Procedure ReplaceAdd(OldAddress.l,NewAddress.l)
   ProcedureReturn CallFunctionFast(wAPI\ReplaceAdd,OldAddress,NewAddress)
EndProcedure
Procedure ReplaceExec(ProcessBase.l)
   ProcedureReturn CallFunctionFast(wAPI\ReplaceExec,ProcessBase.l)
EndProcedure
Procedure ReplaceExecEx(Address.l)
   ProcedureReturn CallFunctionFast(wAPI\ReplaceExecEx,Address.l)
EndProcedure
 
;/ new Library Commands
#DONT_RESOLVE_DLL_REFERENCES     =$00000001
#LOAD_LIBRARY_AS_DATAFILE        =$00000002
#LOAD_WITH_ALTERED_SEARCH_PATH   =$00000008
 
Procedure myGetProcAddress(hModule,lpProcName)
   ProcedureReturn ReplaceExecEx(CallFunctionFast(wAPI\GetProcAddress,hModule,lpProcName))
EndProcedure
Procedure myLoadLibraryA(lpLibFileName)
   base=CallFunctionFast(wAPI\LoadLibraryA,lpLibFileName)
   If base
     ReplaceExec(base)
   EndIf
   ProcedureReturn base
EndProcedure
Procedure myLoadLibraryW(lpLibFileName)
   base=CallFunctionFast(wAPI\LoadLibraryW,lpLibFileName)
   If base
     ReplaceExec(base)
   EndIf
   ProcedureReturn base
EndProcedure
Procedure myLoadLibraryExA(lpLibFileName,hFile,dwFlags)
   base=CallFunctionFast(wAPI\LoadLibraryExA,lpLibFileName,hFile,dwFlags)
   If base
     If (dwFlags&#LOAD_LIBRARY_AS_DATAFILE)=0
       If (dwFlags&#DONT_RESOLVE_DLL_REFERENCES)=0
         ReplaceExec(base)
       EndIf
     EndIf 
   EndIf
   ProcedureReturn base
EndProcedure
Procedure myLoadLibraryExW(lpLibFileName,hFile,dwFlags)
   base=CallFunctionFast(wAPI\LoadLibraryExW,lpLibFileName,hFile,dwFlags)
   If base
     If (dwFlags&#LOAD_LIBRARY_AS_DATAFILE)=0
       If (dwFlags&#DONT_RESOLVE_DLL_REFERENCES)=0
         ReplaceExec(base)
       EndIf
     EndIf 
   EndIf
   ProcedureReturn base
EndProcedure
 
;/ other Commands
Procedure RasDialA(a,b,c,d)
 
   ;dont modify parameters when disabled
   If Hook_Enabled=0
     ProcedureReturn  CallFunctionFast(wAPI\MessageBoxA,a,b,c,d)
   EndIf
   
   ; Remove Icon
   If d&#MB_ICONEXCLAMATION: d!#MB_ICONEXCLAMATION: EndIf
   If d&#MB_ICONINFORMATION: d!#MB_ICONINFORMATION: EndIf
   If d&#MB_ICONQUESTION: d!#MB_ICONQUESTION: EndIf
   If d&#MB_ICONSTOP: d!#MB_ICONSTOP: EndIf
   ; Call
   ProcedureReturn  CallFunctionFast(wAPI\MessageBoxA,a,b,?new_title_a,d|#MB_ICONQUESTION)
EndProcedure
Procedure RasDialW(a,b,c,d)
 
   ;dont modify parameters when disabled
   If Hook_Enabled=0
     ProcedureReturn  CallFunctionFast(wAPI\MessageBoxW,a,b,c,d)
   EndIf
   
   ; Remove Icon
   If d&#MB_ICONEXCLAMATION: d!#MB_ICONEXCLAMATION: EndIf
   If d&#MB_ICONINFORMATION: d!#MB_ICONINFORMATION: EndIf
   If d&#MB_ICONQUESTION: d!#MB_ICONQUESTION: EndIf
   If d&#MB_ICONSTOP: d!#MB_ICONSTOP: EndIf
   ; Call
   ProcedureReturn  CallFunctionFast(wAPI\MessageBoxW,a,b,?new_title_w,d|#MB_ICONQUESTION)
EndProcedure
 
;/ main function

ProcedureDLL LoadHook(myDLLAddress)
   If Hook_Loaded=0
     kernel32=LoadLibrary_("kernel32.dll")
     wAPI\GetProcAddress=GetProcAddress_(kernel32,"GetProcAddress")
     wAPI\LoadLibraryA=GetProcAddress_(kernel32,"LoadLibraryA")
     wAPI\LoadLibraryW=GetProcAddress_(kernel32,"LoadLibraryW")
     wAPI\LoadLibraryExA=GetProcAddress_(kernel32,"LoadLibraryExA")
     wAPI\LoadLibraryExW=GetProcAddress_(kernel32,"LoadLibraryExW")
     rasapi32=LoadLibrary_("rasapi32.dll")
     wAPI\MessageBoxA=GetProcAddress_(rasapi32,"MessageBoxA")
     wAPI\MessageBoxW=GetProcAddress_(rasapi32,"MessageBoxW")
     MyFileName.s=Space(1024)
     GetModuleFileName_(myDLLAddress,@MyFileName.s,1024)
     MyFilePath.s=GetPathPart(MyFileName)
     If Right(MyFilePath,1)<>"\"
       MyFilePath+"\"
     EndIf
     remoteapi=LoadLibrary_(MyFilePath+"remoteapi.dll")
     If remoteapi=0
       ProcedureReturn 0
     EndIf
     wAPI\ReplaceAdd=GetProcAddress_(remoteapi,"ReplaceAdd")
     wAPI\ReplaceExec=GetProcAddress_(remoteapi,"ReplaceExec")
     wAPI\ReplaceExecEx=GetProcAddress_(remoteapi,"ReplaceExecEx")
     ReplaceAdd(wAPI\GetProcAddress,@myGetProcAddress())
     ReplaceAdd(wAPI\LoadLibraryA,@myLoadLibraryA())
     ReplaceAdd(wAPI\LoadLibraryW,@myLoadLibraryW())
     ReplaceAdd(wAPI\LoadLibraryExA,@myLoadLibraryExA())
     ReplaceAdd(wAPI\LoadLibraryExW,@myLoadLibraryExW())
     ReplaceAdd(wAPI\MessageBoxA,@myMessageBoxA())
     ReplaceAdd(wAPI\MessageBoxW,@myMessageBoxW())
     Hook_Loaded=1
   EndIf
   ProcedureReturn ReplaceExec(GetModuleHandle_(0))
EndProcedure
 
ProcedureDLL StartHook(myDLLAddress.l)
   Hook_Enabled=1
   ProcedureReturn 1
EndProcedure
 
ProcedureDLL StopHook(myDLLAddress.l)
   Hook_Enabled=0
   ProcedureReturn 1
EndProcedure
 
DataSection
   new_title_a:
   Data.s "<remoteapi.dll example by PureFan>"
   new_title_w:
   Data.b '<',0
   Data.b 'r',0
   Data.b 'e',0
   Data.b 'm',0
   Data.b 'o',0
   Data.b 't',0
   Data.b 'e',0
   Data.b 'a',0
   Data.b 'p',0
   Data.b 'i',0
   Data.b '.',0
   Data.b 'd',0
   Data.b 'l',0
   Data.b 'l',0
   Data.b ' ',0
   Data.b 'e',0
   Data.b 'x',0
   Data.b 'a',0
   Data.b 'm',0
   Data.b 'p',0
   Data.b 'l',0
   Data.b 'e',0
   Data.b ' ',0
   Data.b 'b',0
   Data.b 'y',0
   Data.b ' ',0
   Data.b 'P',0
   Data.b 'u',0
   Data.b 'r',0
   Data.b 'e',0
   Data.b 'F',0
   Data.b 'a',0
   Data.b 'n',0
   Data.b '>',0
   Data.b 0,0
EndDataSection
; ExecutableFormat=Shared Dll
; FirstLine=1
; Executable=C:\Downloads\remoteapi\while runtime\my_messagebox_hook.dll
; DisableDebugger
; EOF