;EXE
 
 Structure PROCESSENTRY32
   dwSize.l
   cntUsage.l
   th32ProcessID.l
   th32DefaultHeapID.l
   th32ModuleID.l
   cntThreads.l
   th32ParentProcessID.l
   pcPriClassBase.l
   dwFlags.l
   szExeFile.b[#MAX_PATH]
 EndStructure
 
 Structure THREADENTRY32
   dwSize.l
   cntUsage.l
   th32ThreadID.l
   th32OwnerProcessID.l
   tpBasePri.l
   tpDeltaPri.l
   dwFlags.l
 EndStructure
 
 #TH32CS_SNAPHEAPLIST=1
 #TH32CS_SNAPPROCESS=2
 #TH32CS_SNAPTHREAD=4
 #TH32CS_SNAPMODULE=8
 #TH32CS_SNAPALL=1|2|4|8
 #PROCESS_ALL_ACCESS = $1F0FFF
 
 Procedure SearchProcessThread(FileName.s,*hProcess.LONG,*hThread.LONG,*PID.LONG,*TID.LONG)
   FileName=LCase(FileName)
   hKernel=LoadLibrary_("kernel32.dll")
   CreateToolhelp32Snapshot=GetProcAddress_(hKernel,"CreateToolhelp32Snapshot")
   Thread32First=GetProcAddress_(hKernel,"Thread32First")
   Thread32Next=GetProcAddress_(hKernel,"Thread32Next")
   OpenThread=GetProcAddress_(hKernel,"OpenThread")
   Process32First=GetProcAddress_(hKernel,"Process32First")
   Process32Next=GetProcAddress_(hKernel,"Process32Next")
   OpenProcess=GetProcAddress_(hKernel,"OpenProcess")
 
   PID=0
   hProcessSnap=CallFunctionFast(CreateToolhelp32Snapshot,#TH32CS_SNAPPROCESS,0)
   If hProcessSnap=-1
     ProcedureReturn 0
   EndIf
   pe32.PROCESSENTRY32
   pe32\dwSize=SizeOf(PROCESSENTRY32)
   If CallFunctionFast(Process32First,hProcessSnap,@pe32)
     Repeat
       name.s=LCase(PeekS(@pe32\szExeFile,#MAX_PATH))
       If FindString(name,filename,1)
         PID=pe32\th32ProcessID
       EndIf 
     Until CallFunctionFast(Process32Next,hProcessSnap,@pe32)=0
     CloseHandle_(hProcessSnap)
   EndIf
   If PID=0
     ProcedureReturn 0
   EndIf
   hThreadSnap=CallFunctionFast(CreateToolhelp32Snapshot,#TH32CS_SNAPTHREAD,0)
   If hThreadSnap=-1
     ProcedureReturn 0
   EndIf
   te32.THREADENTRY32
   te32\dwSize=SizeOf(THREADENTRY32)
   If CallFunctionFast(Thread32First,hThreadSnap,@te32)
     Repeat
       If te32\th32OwnerProcessID=PID
         *hThread\l=CallFunctionFast(OpenThread,$100000|$3FF|$F0000|$2,0,te32\th32ThreadID)
         *hProcess\l=CallFunctionFast(OpenProcess,#PROCESS_ALL_ACCESS,0,PID)
         *PID\l=PID
         *TID\l=te32\th32ThreadID
         CloseHandle_(hThreadSnap)
         FreeLibrary_(hKernel)
         ProcedureReturn 1
       EndIf
     Until CallFunctionFast(Thread32Next,hThreadSnap,@te32)=0
     CloseHandle_(hThreadSnap)
   EndIf
   FreeLibrary_(hKernel)
 EndProcedure
 
 ;-
 
 Procedure GetKernelAddress(funktion.s)
   hKernel=LoadLibrary_("kernel32.dll")
   func=GetProcAddress_(hKernel,funktion)
   FreeLibrary_(hKernel)
   ProcedureReturn func
 EndProcedure
 Procedure RemoteGetProcAddress_(DLL_intern.l,funktion.s,DLL_extern.l)
   func=GetProcAddress_(DLL_intern,funktion)
   If func
     ProcedureReturn (func-DLL_intern)+DLL_extern
   EndIf
 EndProcedure
 
 If OpenLibrary(0,"remoteapi.dll")=0
   Debug "remoteapi.dll not found - Canceled"
   End
 EndIf
 
 pinfo.PROCESS_INFORMATION
 If SearchProcessThread("notepad.exe",@pinfo\hProcess,@pinfo\hThread,@pinfo\dwProcessID,@pinfo\dwThreadID)=0
   Debug "Unable to find exe"
   End
 EndIf
 
 While SuspendThread_(pinfo\hThread)<0
 Wend
 PostThreadMessage_(pinfo\dwThreadID,0,0,0)
 
 If CallFunction(0,"RemoteAPIInit",pinfo\hProcess,pinfo\hThread)=0
   Debug "Unable to set current process/thread - Canceled"
   Goto ResumeAPIProcess
 EndIf
 
 MyFileName.s=Space(1024)
 GetModuleFileName_(0,@MyFileName.s,1024)
 MyFilePath.s=GetPathPart(MyFileName)
 If Right(MyFilePath,1)<>"\"
   MyFilePath+"\"
 EndIf
 DLL_name.s=MyFilePath+"my_messagebox_hook.dll"
 DLL_intern = LoadLibrary_(DLL_name)
 
              CallFunction(0,"RemoteAPIAdd",@DLL_name,Len(DLL_name)+1)
 DLL_extern = CallFunction(0,"RemoteAPIExec",GetKernelAddress("LoadLibraryA"),10)
 
 If DLL_intern=0 Or DLL_extern=0
   Debug "Loading dll failed"
   Goto ResumeAPIProcess
 EndIf
 
 Debug "DLL-intern: 0x"+Hex(DLL_intern)
 Debug "DLL-extern: 0x"+Hex(DLL_extern)
 
 
 type=MessageRequester("Start or Stop?!","OK = Start, CANCEL = Stop",#MB_OKCANCEL)
 
              CallFunction(0,"RemoteAPIAdd",DLL_extern,0)
 result     = CallFunction(0,"RemoteAPIExec",RemoteGetProcAddress_(DLL_intern,"LoadHook",DLL_extern),10)
   
 If type=#IDOK
                CallFunction(0,"RemoteAPIAdd",DLL_extern,0)
   result     = CallFunction(0,"RemoteAPIExec",RemoteGetProcAddress_(DLL_intern,"StartHook",DLL_extern),10)
 Else
                CallFunction(0,"RemoteAPIAdd",DLL_extern,0)
   result     = CallFunction(0,"RemoteAPIExec",RemoteGetProcAddress_(DLL_intern,"StopHook",DLL_extern),10)
 EndIf
 
 If result=0
   Debug "Hooking failed :("
 EndIf
 
 
 ResumeAPIProcess:
 While ResumeThread_(pinfo\hThread)>1
 Wend
; ExecutableFormat=Windows
; CursorPosition=161
; FirstLine=117
; Executable=C:\Downloads\remoteapi\while runtime\Test.exe
; EOF